Package org.flowable.cmmn.api.runtime

# Interface PlanItemInstanceQuery

All Superinterfaces:
  `Query<PlanItemInstanceQuery,PlanItemInstance>`

public interface PlanItemInstanceQuery extends Query<PlanItemInstanceQuery,PlanItemInstance>
Allows to query for `PlanItemInstance`s. By default, as with other Flowable runtime API's, only runtime (not ended) plan item instances are returned. However, `PlanItemInstance` entities are only removed once a case instance has ended. This means that `PlanItemInstance` entities can still be queries when the case instance hasn't finished yet. To return the 'ended' (i.e. completed/terminated/exit/occurred) instances, use the `ended()` or `includeEnded()` methods.

Author:
  Joram Barrez, Tijs Rademakers

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.flowable.common.engine.api.query.Query

  `Query.NullHandlingOnOrder`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PlanItemInstanceQuery`
  `caseDefinitionId(String caseDefinitionId)`
  `PlanItemInstanceQuery`
  `caseInstanceId(String caseInstanceId)`
  `PlanItemInstanceQuery`
  `caseVariableExists(String name)`
  Only select plan item instances which have a global variable with the given name.
  `PlanItemInstanceQuery`
  `caseVariableNotExists(String name)`
  Only select plan item instances which don't have a global variable with the given name.
  `PlanItemInstanceQuery`
  `caseVariableValueEquals(Object value)`
  Only select plan item instances which have at least one global variable with the given value.
  `PlanItemInstanceQuery`
  `caseVariableValueEquals(String name, Object value)`
  Only select plan item instances which have a global variable with the given value.
  `PlanItemInstanceQuery`
  `caseVariableValueEqualsIgnoreCase(String name, String value)`
  Only select plan item instances which have a global string variable with the given value, case insensitive.
  `PlanItemInstanceQuery`
  `caseVariableValueGreaterThan(String name, Object value)`
  Only select plan item instances which have a global variable value greater than the passed value.
  `PlanItemInstanceQuery`
  `caseVariableValueGreaterThanOrEqual(String name, Object value)`
  Only select plan item instances which have a global variable value greater than or equal to the passed value.
  `PlanItemInstanceQuery`
  `caseVariableValueLessThan(String name, Object value)`
  Only select plan item instances which have a global variable value less than the passed value.
  `PlanItemInstanceQuery`
  `caseVariableValueLessThanOrEqual(String name, Object value)`
  Only select plan item instances which have a global variable value less than or equal to the passed value.
  `PlanItemInstanceQuery`
  `caseVariableValueLike(String name, String value)`
  Only select plan item instances which have a global variable value like the given value.
  `PlanItemInstanceQuery`
  `caseVariableValueLikeIgnoreCase(String name, String value)`
  Only select plan item instances which have a global variable value like the given value (case insensitive).
  `PlanItemInstanceQuery`
  `caseVariableValueNotEquals(String name, Object value)`
  Only select plan item instances which have a global variable with the given name, but with a different value than the passed value.
  `PlanItemInstanceQuery`
  `caseVariableValueNotEqualsIgnoreCase(String name, String value)`
  Only select plan item instances which have a global string variable which is not the given value, case insensitive.
  `PlanItemInstanceQuery`
  `derivedCaseDefinitionId(String derivedCaseDefinitionId)`
  `PlanItemInstanceQuery`
  `ended()`
  `PlanItemInstanceQuery`
  `endOr()`
  End an OR statement.
  `PlanItemInstanceQuery`
  `includeEnded()`
  `PlanItemInstanceQuery`
  `includeLocalVariables()`
  Include local plan item instance variables in the query result
  `PlanItemInstanceQuery`
  `involvedGroups(Collection<String> involvedGroups)`
  `PlanItemInstanceQuery`
  `involvedUser(String involvedUser)`
  `PlanItemInstanceQuery`
  `locale(String locale)`
  Localize plan item name to specified locale.
  `PlanItemInstanceQuery`
  `onlyStages()`
  `PlanItemInstanceQuery`
  `or()`
  Begin an OR statement.
  `PlanItemInstanceQuery`
  `orderByCreateTime()`
  `PlanItemInstanceQuery`
  `orderByEndTime()`
  `PlanItemInstanceQuery`
  `orderByName()`
  `PlanItemInstanceQuery`
  `planItemDefinitionId(String planItemDefinitionId)`
  `PlanItemInstanceQuery`
  `planItemDefinitionType(String planItemDefinitionType)`
  `PlanItemInstanceQuery`
  `planItemDefinitionTypes(List<String> planItemDefinitionType)`
  `PlanItemInstanceQuery`
  `planItemInstanceAssignee(String assignee)`
  `PlanItemInstanceQuery`
  `planItemInstanceCompletable()`
  `PlanItemInstanceQuery`
  `planItemInstanceCompletedAfter(Date completedAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceCompletedBefore(Date completedBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceCompletedBy(String completedBy)`
  `PlanItemInstanceQuery`
  `planItemInstanceCreatedAfter(Date createdAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceCreatedBefore(Date createdBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceElementId(String elementId)`
  `PlanItemInstanceQuery`
  `planItemInstanceEndedAfter(Date endedAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceEndedBefore(Date endedBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceEntryCriterionId(String entryCriterionId)`
  `PlanItemInstanceQuery`
  `planItemInstanceExitAfter(Date exitAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceExitBefore(Date exitBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceExitCriterionId(String exitCriterionId)`
  `PlanItemInstanceQuery`
  `planItemInstanceExtraValue(String extraValue)`
  `PlanItemInstanceQuery`
  `planItemInstanceFormKey(String formKey)`
  `PlanItemInstanceQuery`
  `planItemInstanceId(String planItemInstanceId)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastAvailableAfter(Date availableAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastAvailableBefore(Date availableBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastDisabledAfter(Date disabledAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastDisabledBefore(Date disabledBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastEnabledAfter(Date enabledAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastEnabledBefore(Date enabledBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastStartedAfter(Date startedAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastStartedBefore(Date startedBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastSuspendedAfter(Date suspendedAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastSuspendedBefore(Date suspendedBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastUnavailableAfter(Date unavailableAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceLastUnavailableBefore(Date unavailableBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceName(String name)`
  `PlanItemInstanceQuery`
  `planItemInstanceOccurredAfter(Date occurredAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceOccurredBefore(Date occurredBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceReferenceId(String referenceId)`
  `PlanItemInstanceQuery`
  `planItemInstanceReferenceType(String referenceType)`
  `PlanItemInstanceQuery`
  `planItemInstanceStartUserId(String startUserId)`
  `PlanItemInstanceQuery`
  `planItemInstanceState(String state)`
  `PlanItemInstanceQuery`
  `planItemInstanceStateActive()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateAsyncActive()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateAsyncActiveLeave()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateAvailable()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateCompleted()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateDisabled()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateEnabled()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateTerminated()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateUnavailable()`
  `PlanItemInstanceQuery`
  `planItemInstanceStateWaitingForRepetition()`
  `PlanItemInstanceQuery`
  `planItemInstanceTenantId(String tenantId)`
  `PlanItemInstanceQuery`
  `planItemInstanceTerminatedAfter(Date terminatedAfter)`
  `PlanItemInstanceQuery`
  `planItemInstanceTerminatedBefore(Date terminatedBefore)`
  `PlanItemInstanceQuery`
  `planItemInstanceWithoutTenantId()`
  `PlanItemInstanceQuery`
  `stageInstanceId(String stageInstanceId)`
  `PlanItemInstanceQuery`
  `variableExists(String name)`
  Only select plan item instances which have a local variable with the given name.
  `PlanItemInstanceQuery`
  `variableNotExists(String name)`
  Only select plan item instances which don't have a local variable with the given name.
  `PlanItemInstanceQuery`
  `variableValueEquals(Object value)`
  Only select plan item instances which have at least one local variable with the given value.
  `PlanItemInstanceQuery`
  `variableValueEquals(String name, Object value)`
  Only select plan item instances which have a local variable with the given value.
  `PlanItemInstanceQuery`
  `variableValueEqualsIgnoreCase(String name, String value)`
  Only select plan item instances which have a local string variable with the given value, case insensitive.
  `PlanItemInstanceQuery`
  `variableValueGreaterThan(String name, Object value)`
  Only select plan item instances which have a local variable value greater than the passed value.
  `PlanItemInstanceQuery`
  `variableValueGreaterThanOrEqual(String name, Object value)`
  Only select plan item instances which have a local variable value greater than or equal to the passed value.
  `PlanItemInstanceQuery`
  `variableValueLessThan(String name, Object value)`
  Only select plan item instances which have a local variable value less than the passed value.
  `PlanItemInstanceQuery`
  `variableValueLessThanOrEqual(String name, Object value)`
  Only select plan item instances which have a local variable value less than or equal to the passed value.
  `PlanItemInstanceQuery`
  `variableValueLike(String name, String value)`
  Only select plan item instances which have a local variable value like the given value.
  `PlanItemInstanceQuery`
  `variableValueLikeIgnoreCase(String name, String value)`
  Only select plan item instances which have a local variable value like the given value (case insensitive).
  `PlanItemInstanceQuery`
  `variableValueNotEquals(String name, Object value)`
  Only select plan item instances which have a local variable with the given name, but with a different value than the passed value.
  `PlanItemInstanceQuery`
  `variableValueNotEqualsIgnoreCase(String name, String value)`
  Only select plan item instances which have a local string variable which is not the given value, case insensitive.
  `PlanItemInstanceQuery`
  `withLocalizationFallback()`
  Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

  ### Methods inherited from interface org.flowable.common.engine.api.query.Query

  `asc, count, desc, list, listPage, orderBy, orderBy, singleResult`

- ## Method Details

  - ### caseDefinitionId

    PlanItemInstanceQuery caseDefinitionId(String caseDefinitionId)

  - ### derivedCaseDefinitionId

    PlanItemInstanceQuery derivedCaseDefinitionId(String derivedCaseDefinitionId)

  - ### caseInstanceId

    PlanItemInstanceQuery caseInstanceId(String caseInstanceId)

  - ### stageInstanceId

    PlanItemInstanceQuery stageInstanceId(String stageInstanceId)

  - ### planItemInstanceId

    PlanItemInstanceQuery planItemInstanceId(String planItemInstanceId)

  - ### planItemInstanceElementId

    PlanItemInstanceQuery planItemInstanceElementId(String elementId)

  - ### planItemInstanceName

    PlanItemInstanceQuery planItemInstanceName(String name)

  - ### planItemInstanceState

    PlanItemInstanceQuery planItemInstanceState(String state)

  - ### planItemInstanceStateWaitingForRepetition

    PlanItemInstanceQuery planItemInstanceStateWaitingForRepetition()

  - ### planItemInstanceStateEnabled

    PlanItemInstanceQuery planItemInstanceStateEnabled()

  - ### planItemInstanceStateDisabled

    PlanItemInstanceQuery planItemInstanceStateDisabled()

  - ### planItemInstanceStateActive

    PlanItemInstanceQuery planItemInstanceStateActive()

  - ### planItemInstanceStateAsyncActive

    PlanItemInstanceQuery planItemInstanceStateAsyncActive()

  - ### planItemInstanceStateAsyncActiveLeave

    PlanItemInstanceQuery planItemInstanceStateAsyncActiveLeave()

  - ### planItemInstanceStateAvailable

    PlanItemInstanceQuery planItemInstanceStateAvailable()

  - ### planItemInstanceStateUnavailable

    PlanItemInstanceQuery planItemInstanceStateUnavailable()

  - ### planItemInstanceStateCompleted

    PlanItemInstanceQuery planItemInstanceStateCompleted()

  - ### planItemInstanceStateTerminated

    PlanItemInstanceQuery planItemInstanceStateTerminated()

  - ### planItemInstanceCreatedBefore

    PlanItemInstanceQuery planItemInstanceCreatedBefore(Date createdBefore)

  - ### planItemInstanceCreatedAfter

    PlanItemInstanceQuery planItemInstanceCreatedAfter(Date createdAfter)

  - ### planItemInstanceLastAvailableBefore

    PlanItemInstanceQuery planItemInstanceLastAvailableBefore(Date availableBefore)

  - ### planItemInstanceLastAvailableAfter

    PlanItemInstanceQuery planItemInstanceLastAvailableAfter(Date availableAfter)

  - ### planItemInstanceLastUnavailableBefore

    PlanItemInstanceQuery planItemInstanceLastUnavailableBefore(Date unavailableBefore)

  - ### planItemInstanceLastUnavailableAfter

    PlanItemInstanceQuery planItemInstanceLastUnavailableAfter(Date unavailableAfter)

  - ### planItemInstanceLastEnabledBefore

    PlanItemInstanceQuery planItemInstanceLastEnabledBefore(Date enabledBefore)

  - ### planItemInstanceLastEnabledAfter

    PlanItemInstanceQuery planItemInstanceLastEnabledAfter(Date enabledAfter)

  - ### planItemInstanceLastDisabledBefore

    PlanItemInstanceQuery planItemInstanceLastDisabledBefore(Date disabledBefore)

  - ### planItemInstanceLastDisabledAfter

    PlanItemInstanceQuery planItemInstanceLastDisabledAfter(Date disabledAfter)

  - ### planItemInstanceLastStartedBefore

    PlanItemInstanceQuery planItemInstanceLastStartedBefore(Date startedBefore)

  - ### planItemInstanceLastStartedAfter

    PlanItemInstanceQuery planItemInstanceLastStartedAfter(Date startedAfter)

  - ### planItemInstanceLastSuspendedBefore

    PlanItemInstanceQuery planItemInstanceLastSuspendedBefore(Date suspendedBefore)

  - ### planItemInstanceLastSuspendedAfter

    PlanItemInstanceQuery planItemInstanceLastSuspendedAfter(Date suspendedAfter)

  - ### planItemInstanceCompletedBefore

    PlanItemInstanceQuery planItemInstanceCompletedBefore(Date completedBefore)

  - ### planItemInstanceCompletedAfter

    PlanItemInstanceQuery planItemInstanceCompletedAfter(Date completedAfter)

  - ### planItemInstanceOccurredBefore

    PlanItemInstanceQuery planItemInstanceOccurredBefore(Date occurredBefore)

  - ### planItemInstanceOccurredAfter

    PlanItemInstanceQuery planItemInstanceOccurredAfter(Date occurredAfter)

  - ### planItemInstanceTerminatedBefore

    PlanItemInstanceQuery planItemInstanceTerminatedBefore(Date terminatedBefore)

  - ### planItemInstanceTerminatedAfter

    PlanItemInstanceQuery planItemInstanceTerminatedAfter(Date terminatedAfter)

  - ### planItemInstanceExitBefore

    PlanItemInstanceQuery planItemInstanceExitBefore(Date exitBefore)

  - ### planItemInstanceExitAfter

    PlanItemInstanceQuery planItemInstanceExitAfter(Date exitAfter)

  - ### planItemInstanceEndedBefore

    PlanItemInstanceQuery planItemInstanceEndedBefore(Date endedBefore)

  - ### planItemInstanceEndedAfter

    PlanItemInstanceQuery planItemInstanceEndedAfter(Date endedAfter)

  - ### planItemInstanceStartUserId

    PlanItemInstanceQuery planItemInstanceStartUserId(String startUserId)

  - ### planItemInstanceAssignee

    PlanItemInstanceQuery planItemInstanceAssignee(String assignee)

  - ### planItemInstanceCompletedBy

    PlanItemInstanceQuery planItemInstanceCompletedBy(String completedBy)

  - ### planItemInstanceReferenceId

    PlanItemInstanceQuery planItemInstanceReferenceId(String referenceId)

  - ### planItemInstanceReferenceType

    PlanItemInstanceQuery planItemInstanceReferenceType(String referenceType)

  - ### planItemInstanceEntryCriterionId

    PlanItemInstanceQuery planItemInstanceEntryCriterionId(String entryCriterionId)

  - ### planItemInstanceExitCriterionId

    PlanItemInstanceQuery planItemInstanceExitCriterionId(String exitCriterionId)

  - ### planItemInstanceFormKey

    PlanItemInstanceQuery planItemInstanceFormKey(String formKey)

  - ### planItemInstanceExtraValue

    PlanItemInstanceQuery planItemInstanceExtraValue(String extraValue)

  - ### planItemInstanceCompletable

    PlanItemInstanceQuery planItemInstanceCompletable()

  - ### onlyStages

    PlanItemInstanceQuery onlyStages()

  - ### involvedUser

    PlanItemInstanceQuery involvedUser(String involvedUser)

  - ### involvedGroups

    PlanItemInstanceQuery involvedGroups(Collection<String> involvedGroups)

  - ### planItemInstanceTenantId

    PlanItemInstanceQuery planItemInstanceTenantId(String tenantId)

  - ### planItemInstanceWithoutTenantId

    PlanItemInstanceQuery planItemInstanceWithoutTenantId()

  - ### planItemDefinitionId

    PlanItemInstanceQuery planItemDefinitionId(String planItemDefinitionId)

  - ### planItemDefinitionType

    PlanItemInstanceQuery planItemDefinitionType(String planItemDefinitionType)

  - ### planItemDefinitionTypes

    PlanItemInstanceQuery planItemDefinitionTypes(List<String> planItemDefinitionType)

  - ### or

    PlanItemInstanceQuery or()
    Begin an OR statement. Make sure you invoke the endOr method at the end of your OR statement.

  - ### endOr

    PlanItemInstanceQuery endOr()
    End an OR statement.

  - ### ended

    PlanItemInstanceQuery ended()
    Returns:
      The query will only return ended (completed/terminated/occurred/exited) plan item instances. No runtime instances will be returned.

  - ### includeEnded

    PlanItemInstanceQuery includeEnded()
    Returns:
      The query will include both runtime and ended (completed/terminated/occurred/exited) plan item instances.

  - ### variableValueEquals

    PlanItemInstanceQuery variableValueEquals(String name, Object value)
    Only select plan item instances which have a local variable with the given value. The type of variable is determined based on the value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - name of the variable, cannot be null.

  - ### variableValueEquals

    PlanItemInstanceQuery variableValueEquals(Object value)
    Only select plan item instances which have at least one local variable with the given value. The type of variable is determined based on the value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

  - ### variableValueEqualsIgnoreCase

    PlanItemInstanceQuery variableValueEqualsIgnoreCase(String name, String value)
    Only select plan item instances which have a local string variable with the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    Parameters:
      `name` - name of the variable, cannot be null.
      `value` - value of the variable, cannot be null.

  - ### variableValueNotEquals

    PlanItemInstanceQuery variableValueNotEquals(String name, Object value)
    Only select plan item instances which have a local variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - name of the variable, cannot be null.

  - ### variableValueNotEqualsIgnoreCase

    PlanItemInstanceQuery variableValueNotEqualsIgnoreCase(String name, String value)
    Only select plan item instances which have a local string variable which is not the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    Parameters:
      `name` - name of the variable, cannot be null.
      `value` - value of the variable, cannot be null.

  - ### variableValueGreaterThan

    PlanItemInstanceQuery variableValueGreaterThan(String name, Object value)
    Only select plan item instances which have a local variable value greater than the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### variableValueGreaterThanOrEqual

    PlanItemInstanceQuery variableValueGreaterThanOrEqual(String name, Object value)
    Only select plan item instances which have a local variable value greater than or equal to the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### variableValueLessThan

    PlanItemInstanceQuery variableValueLessThan(String name, Object value)
    Only select plan item instances which have a local variable value less than the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### variableValueLessThanOrEqual

    PlanItemInstanceQuery variableValueLessThanOrEqual(String name, Object value)
    Only select plan item instances which have a local variable value less than or equal to the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### variableValueLike

    PlanItemInstanceQuery variableValueLike(String name, String value)
    Only select plan item instances which have a local variable value like the given value. This be used on string variables only.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### variableValueLikeIgnoreCase

    PlanItemInstanceQuery variableValueLikeIgnoreCase(String name, String value)
    Only select plan item instances which have a local variable value like the given value (case insensitive). This be used on string variables only.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### variableExists

    PlanItemInstanceQuery variableExists(String name)
    Only select plan item instances which have a local variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### variableNotExists

    PlanItemInstanceQuery variableNotExists(String name)
    Only select plan item instances which don't have a local variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### caseVariableValueEquals

    PlanItemInstanceQuery caseVariableValueEquals(String name, Object value)
    Only select plan item instances which have a global variable with the given value. The type of variable is determined based on the value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - name of the variable, cannot be null.

  - ### caseVariableValueEquals

    PlanItemInstanceQuery caseVariableValueEquals(Object value)
    Only select plan item instances which have at least one global variable with the given value. The type of variable is determined based on the value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.

  - ### caseVariableValueEqualsIgnoreCase

    PlanItemInstanceQuery caseVariableValueEqualsIgnoreCase(String name, String value)
    Only select plan item instances which have a global string variable with the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    Parameters:
      `name` - name of the variable, cannot be null.
      `value` - value of the variable, cannot be null.

  - ### caseVariableValueNotEquals

    PlanItemInstanceQuery caseVariableValueNotEquals(String name, Object value)
    Only select plan item instances which have a global variable with the given name, but with a different value than the passed value. Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - name of the variable, cannot be null.

  - ### caseVariableValueNotEqualsIgnoreCase

    PlanItemInstanceQuery caseVariableValueNotEqualsIgnoreCase(String name, String value)
    Only select plan item instances which have a global string variable which is not the given value, case insensitive.

    This method only works if your database has encoding/collation that supports case-sensitive queries. For example, use "collate UTF-8" on MySQL and for MSSQL, select one of the case-sensitive Collations available (MSDN Server Collation Reference).

    Parameters:
      `name` - name of the variable, cannot be null.
      `value` - value of the variable, cannot be null.

  - ### caseVariableValueGreaterThan

    PlanItemInstanceQuery caseVariableValueGreaterThan(String name, Object value)
    Only select plan item instances which have a global variable value greater than the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### caseVariableValueGreaterThanOrEqual

    PlanItemInstanceQuery caseVariableValueGreaterThanOrEqual(String name, Object value)
    Only select plan item instances which have a global variable value greater than or equal to the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### caseVariableValueLessThan

    PlanItemInstanceQuery caseVariableValueLessThan(String name, Object value)
    Only select plan item instances which have a global variable value less than the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### caseVariableValueLessThanOrEqual

    PlanItemInstanceQuery caseVariableValueLessThanOrEqual(String name, Object value)
    Only select plan item instances which have a global variable value less than or equal to the passed value. Booleans, Byte-arrays and `Serializable` objects (which are not primitive type wrappers) are not supported.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null.

  - ### caseVariableValueLike

    PlanItemInstanceQuery caseVariableValueLike(String name, String value)
    Only select plan item instances which have a global variable value like the given value. This be used on string variables only.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### caseVariableValueLikeIgnoreCase

    PlanItemInstanceQuery caseVariableValueLikeIgnoreCase(String name, String value)
    Only select plan item instances which have a global variable value like the given value (case insensitive). This be used on string variables only.
    Parameters:
      `name` - variable name, cannot be null.
      `value` - variable value, cannot be null. The string can include the wildcard character '%' to express like-strategy: starts with (string%), ends with (%string) or contains (%string%).

  - ### caseVariableExists

    PlanItemInstanceQuery caseVariableExists(String name)
    Only select plan item instances which have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### caseVariableNotExists

    PlanItemInstanceQuery caseVariableNotExists(String name)
    Only select plan item instances which don't have a global variable with the given name.
    Parameters:
      `name` - cannot be null.

  - ### includeLocalVariables

    PlanItemInstanceQuery includeLocalVariables()
    Include local plan item instance variables in the query result

  - ### locale

    PlanItemInstanceQuery locale(String locale)
    Localize plan item name to specified locale.

  - ### withLocalizationFallback

    PlanItemInstanceQuery withLocalizationFallback()
    Instruct localization to fallback to more general locales including the default locale of the JVM if the specified locale is not found.

  - ### orderByCreateTime

    PlanItemInstanceQuery orderByCreateTime()

  - ### orderByEndTime

    PlanItemInstanceQuery orderByEndTime()

  - ### orderByName

    PlanItemInstanceQuery orderByName()